'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Breadcrumb = function (_Component) {
  _inherits(Breadcrumb, _Component);

  function Breadcrumb(props) {
    _classCallCheck(this, Breadcrumb);

    var _this = _possibleConstructorReturn(this, (Breadcrumb.__proto__ || Object.getPrototypeOf(Breadcrumb)).call(this, props));

    _this._renderRoutes = _this._renderRoutes.bind(_this);
    _this.state = {};
    return _this;
  }

  _createClass(Breadcrumb, [{
    key: 'getRoutes',
    value: function getRoutes() {
      var routes = window.location.pathname.split('/').filter(function (r, i) {
        return r !== '';
      });
      return routes;
    }
  }, {
    key: '_renderRoutes',
    value: function _renderRoutes(route, key, last) {
      if (route === this.props.initialRoute.to) {
        return;
      }
      if (key === last) {
        if (this.props.normalizeRoutes[route]) {
          return _react2.default.createElement(
            'span',
            { key: key, className: 'breadcrumb-item' },
            this.props.normalizeRoutes[route].name
          );
        } else {
          return _react2.default.createElement(
            'span',
            { key: key, className: 'breadcrumb-item' },
            route
          );
        }
      }
      if (this.props.normalizeRoutesDropdown[route]) {
        return _react2.default.createElement(
          'span',
          { key: key, className: 'breadcrumb-item' },
          this.props.normalizeRoutesDropdown[route].to ? _react2.default.createElement(
            _reactRouterDom.Link,
            { to: this.props.normalizeRoutesDropdown[route].to },
            this.props.normalizeRoutesDropdown[route].name
          ) : this.props.normalizeRoutesDropdown[route].name ? this.props.normalizeRoutesDropdown[route].name : route
        );
      } else {
        return _react2.default.createElement(
          'span',
          { key: key, className: 'breadcrumb-item' },
          route
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'ol',
        { className: 'breadcrumb' },
        this.props.initialRoute && _react2.default.createElement(
          'span',
          { className: 'breadcrumb-item' },
          _react2.default.createElement(
            _reactRouterDom.Link,
            { to: '/' + this.props.initialRoute.to },
            this.props.initialRoute.name
          )
        ),
        this.getRoutes().map(function (v, i) {
          return _this2._renderRoutes(v, i, _this2.getRoutes().length - 1);
        })
      );
    }
  }]);

  return Breadcrumb;
}(_react.Component);

Breadcrumb.defaultProps = {
  initialRoute: { to: 'inicio', name: 'Inicio' },
  normalizeRoutes: {},
  normalizeRoutesDropdown: {}
};

Breadcrumb.propTypes = {
  initialRoute: _propTypes2.default.object,
  normalizeRoutes: _propTypes2.default.object,
  normalizeRoutesDropdown: _propTypes2.default.object
};

exports.default = Breadcrumb;