'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Card = function (_Component) {
  _inherits(Card, _Component);

  function Card(props) {
    _classCallCheck(this, Card);

    var _this = _possibleConstructorReturn(this, (Card.__proto__ || Object.getPrototypeOf(Card)).call(this, props));

    _this.state = {
      propOpen: props.open,
      collapseOpen: !props.animated ? true : props.open,
      textCollapse: !props.animated ? '' : props.open ? 'ocultar contenido' : 'mostrar contenido'
    };
    _this.toggle = _this.toggle.bind(_this);
    return _this;
  }

  _createClass(Card, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.open !== this.state.propOpen) {
        this.setState({
          collapseOpen: nextProps.open,
          propOpen: nextProps.open
        });
      }
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      this.setState({
        collapseOpen: !this.state.collapseOpen,
        textCollapse: !this.state.collapseOpen ? 'ocultar contenido' : 'mostrar contenido'
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactstrap.Col,
        {
          className: 'col-12',
          style: { padding: this.props.fullWidth && 0 },
          xs: this.props.size.xs,
          sm: this.props.size.sm,
          md: this.props.size.md,
          lg: this.props.size.lg,
          xl: this.props.size.xl
        },
        _react2.default.createElement(
          'div',
          {
            className: 'card' + (this.props.outlineColor ? ' card-outline-' + this.props.outlineColor : '') + (this.props.topColor ? ' card-accent-' + this.props.topColor : '') + (this.props.cardColor ? ' card-inverse card-' + this.props.cardColor : '')
          },
          this.props.title && _react2.default.createElement(
            'div',
            { className: 'card-header',
              onClick: this.props.animated && this.toggle,
              style: { cursor: this.props.animated ? 'pointer' : 'default' }
            },
            this.props.icon && _react2.default.createElement(_Icon2.default, this.props.icon),
            this.props.title,
            this.props.nextTitle,
            this.props.animated && _react2.default.createElement(
              'small',
              null,
              _react2.default.createElement(
                'strong',
                null,
                '\xA0\xA0(click para ',
                this.state.textCollapse,
                ')'
              )
            )
          ),
          _react2.default.createElement(
            _reactstrap.Collapse,
            { isOpen: this.state.collapseOpen },
            _react2.default.createElement(
              'div',
              {
                className: 'card-block' + (this.props.fullWidth ? ' row' : '')
              },
              this.props.children
            ),
            this.props.footer && _react2.default.createElement(
              'div',
              { className: 'card-footer' },
              this.props.footer
            )
          )
        )
      );
    }
  }]);

  return Card;
}(_react.Component);

Card.defaultProps = {
  size: {},
  animated: false,
  open: false,
  fullWidth: false
};

Card.propTypes = {
  size: _propTypes2.default.object,
  animated: _propTypes2.default.bool,
  open: _propTypes2.default.bool,
  fullWidth: _propTypes2.default.bool,
  icon: _propTypes2.default.object,
  title: _propTypes2.default.any,
  nextTitle: _propTypes2.default.any,
  outlineColor: _propTypes2.default.string,
  topColor: _propTypes2.default.string,
  cardColor: _propTypes2.default.string,
  footer: _propTypes2.default.any,
  children: _propTypes2.default.any
};

exports.default = Card;