'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldCaptcha = function (_Component) {
  _inherits(FieldCaptcha, _Component);

  function FieldCaptcha(props) {
    _classCallCheck(this, FieldCaptcha);

    var _this = _possibleConstructorReturn(this, (FieldCaptcha.__proto__ || Object.getPrototypeOf(FieldCaptcha)).call(this, props));

    _this.state = {
      captcha: null,
      loadImg: false,
      endpoint: ''
    };
    _this.reloadCaptcha = _this.reloadCaptcha.bind(_this);
    _this._renderIMG = _this._renderIMG.bind(_this);
    _this._renderInput = _this._renderInput.bind(_this);
    return _this;
  }

  _createClass(FieldCaptcha, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.endpoint && nextProps.captcha !== this.state.captcha) {
        this.setState({
          captcha: nextProps.captcha
        });
        this.reloadCaptcha(nextProps.captcha);
      }
    }
  }, {
    key: 'randomNumber',
    value: function randomNumber() {
      return Math.floor(Math.random() * 1000 + 1);
    }
  }, {
    key: 'reloadCaptcha',
    value: function reloadCaptcha(captcha) {
      var _this2 = this;

      this.setState({
        loadImg: false
      }, function () {
        _this2.setState({
          loadImg: true,
          endpoint: _this2.props.endpoint + '?random=' + captcha
        });
      });
    }
  }, {
    key: '_renderIMG',
    value: function _renderIMG() {
      return _react2.default.createElement('img', {
        style: {
          marginTop: '-1.5rem',
          WebkitUserSelect: 'none',
          KhtmlUserSelect: 'none',
          MozUserSelect: 'none',
          OUserSelect: 'none',
          msUserSelect: 'none',
          userSelect: 'none'
        },
        src: this.state.endpoint,
        alt: ''
      });
    }
  }, {
    key: '_renderInput',
    value: function _renderInput() {
      var _this3 = this;

      var _props = this.props,
          autocomplete = _props.autocomplete,
          className = _props.className,
          label = _props.label,
          byField = _props.byField,
          componentClass = _props.componentClass,
          input = _props.input,
          onSelect = _props.onSelect,
          captcha = _props.captcha,
          meta = _props.meta,
          endpoint = _props.endpoint,
          props = _objectWithoutProperties(_props, ['autocomplete', 'className', 'label', 'byField', 'componentClass', 'input', 'onSelect', 'captcha', 'meta', 'endpoint']); // eslint-disable-line


      return _react2.default.createElement(
        _reactstrap.InputGroup,
        { className: className },
        _react2.default.createElement(_reactstrap.Input, _extends({
          id: label && label.replace(/ /g, ''),
          autoComplete: autocomplete ? 'on' : 'off',
          type: componentClass,
          value: input ? !byField ? input.value : input.value[byField] : null,
          onChange: function onChange(event) {
            input.onChange(event.target.value);onSelect ? onSelect(event.target.value) : null;
          } //eslint-disable-line
          , onBlur: input && input.onBlur,
          onFocus: input && input.onFocus
        }, props)),
        _react2.default.createElement(
          _reactstrap.InputGroupAddon,
          {
            onClick: function onClick() {
              return _this3.reloadCaptcha(_this3.randomNumber());
            },
            style: { cursor: 'pointer' }
          },
          _react2.default.createElement(_Icon2.default, {
            bootstrap: 'refresh'
          })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          horizontal = _props2.horizontal,
          required = _props2.required,
          meta = _props2.meta,
          props = _objectWithoutProperties(_props2, ['horizontal', 'required', 'meta']);

      return _react2.default.createElement(
        _reactstrap.FormGroup,
        {
          color: !meta.touched ? '' : meta.valid ? '' : 'danger',
          row: horizontal ? true : undefined
        },
        props.label && _react2.default.createElement(
          _reactstrap.Label,
          {
            'for': props.label.replace(/ /g, ''),
            xs: horizontal && horizontal.labelSize && horizontal.labelSize.xs ? horizontal.labelSize.xs : undefined,
            sm: horizontal && horizontal.labelSize && horizontal.labelSize.sm ? horizontal.labelSize.sm : undefined,
            md: horizontal && horizontal.labelSize && horizontal.labelSize.md ? horizontal.labelSize.md : undefined,
            lg: horizontal && horizontal.labelSize && horizontal.labelSize.lg ? horizontal.labelSize.lg : undefined,
            xl: horizontal && horizontal.labelSize && horizontal.labelSize.xl ? horizontal.labelSize.xl : undefined
          },
          props.label,
          ' ',
          required && _react2.default.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          )
        ),
        horizontal && _react2.default.createElement(
          _reactstrap.Col,
          {
            xs: horizontal && horizontal.inputSize && horizontal.inputSize.xs ? horizontal.inputSize.xs : undefined,
            sm: horizontal && horizontal.inputSize && horizontal.inputSize.sm ? horizontal.inputSize.sm : undefined,
            md: horizontal && horizontal.inputSize && horizontal.inputSize.md ? horizontal.inputSize.md : undefined,
            lg: horizontal && horizontal.inputSize && horizontal.inputSize.lg ? horizontal.inputSize.lg : undefined,
            xl: horizontal && horizontal.inputSize && horizontal.inputSize.xl ? horizontal.inputSize.xl : undefined
          },
          this._renderInput(),
          this.state.loadImg && this._renderIMG(),
          meta.touched && meta.error && _react2.default.createElement(
            _reactstrap.FormFeedback,
            null,
            meta.error
          )
        ),
        !horizontal && this._renderInput(),
        !horizontal && this.state.loadImg && this._renderIMG(),
        !horizontal && meta.touched && meta.error && _react2.default.createElement(
          _reactstrap.FormFeedback,
          null,
          meta.error
        )
      );
    }
  }]);

  return FieldCaptcha;
}(_react.Component);

FieldCaptcha.defaultProps = {
  autocomplete: false
};

FieldCaptcha.propTypes = {
  label: _propTypes2.default.string,
  mask: _propTypes2.default.string,
  required: _propTypes2.default.bool,
  meta: _propTypes2.default.object,
  horizontal: _propTypes2.default.object,
  byField: _propTypes2.default.any,
  componentClass: _propTypes2.default.string,
  input: _propTypes2.default.object,
  onSelect: _propTypes2.default.func,
  className: _propTypes2.default.string,
  autocomplete: _propTypes2.default.bool,
  endpoint: _propTypes2.default.string,
  captcha: _propTypes2.default.number
};

exports.default = FieldCaptcha;