'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ramda = require('ramda');

var _reactstrap = require('reactstrap');

var _reactBootstrap = require('react-bootstrap');

var _reactDropzone = require('react-dropzone');

var _reactDropzone2 = _interopRequireDefault(_reactDropzone);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldFileUpload = function (_Component) {
  _inherits(FieldFileUpload, _Component);

  function FieldFileUpload(props) {
    _classCallCheck(this, FieldFileUpload);

    var _this = _possibleConstructorReturn(this, (FieldFileUpload.__proto__ || Object.getPrototypeOf(FieldFileUpload)).call(this, props));

    var file = false;
    var restore = false;
    if (props.input) {
      file = props.input.value;
      restore = props.input.value;
    }

    _this.state = {
      file: file,
      restore: restore,
      btnRestore: false
    };
    _this.onDrop = _this.onDrop.bind(_this);
    _this.deleteIMG = _this.deleteIMG.bind(_this);
    _this.restoreIMG = _this.restoreIMG.bind(_this);
    return _this;
  }

  _createClass(FieldFileUpload, [{
    key: 'onDrop',
    value: function onDrop(file, reject) {
      var _this2 = this;

      var promise = new Promise(function (resolve, reject) {
        var reader = new FileReader(); // eslint-disable-line
        reader.readAsDataURL(file[0]);
        reader.onload = function () {
          if (reader.result) {
            resolve(reader.result);
          } else {
            reject(Error('Failed converting to base64'));
          }
        };
      });
      promise.then(function (result) {
        _this2.setState({
          file: {
            fileName: file[0].name,
            fileSize: file[0].size,
            fileType: file[0].type,
            preview: file[0].preview,
            base64: result.split(',')[1]
          },
          btnRestore: true
        }, function () {
          _this2.props.input && _this2.props.input.onChange((0, _ramda.merge)(_this2.state.file, { preview: undefined }));
        });
      }, function (err) {
        console.log(err);
      });
    }
  }, {
    key: 'deleteIMG',
    value: function deleteIMG(e) {
      var _this3 = this;

      e.stopPropagation();
      if (this.state.file.preview) {
        window.URL.revokeObjectURL(this.state.file.preview);
      }
      this.setState({
        file: false,
        btnRestore: true
      }, function () {
        _this3.props.input && _this3.props.input.onChange('');
        _this3.props.input && _this3.props.input.onBlur('');
      });
    }
  }, {
    key: 'restoreIMG',
    value: function restoreIMG(e) {
      var _this4 = this;

      e.stopPropagation();
      this.setState({
        file: this.state.restore,
        btnRestore: false
      }, function () {
        _this4.props.input && _this4.props.input.onChange(_this4.state.file);
      });
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return _react2.default.createElement(
        _reactBootstrap.Tooltip,
        { id: 'tooltip' },
        _react2.default.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactDropzone2.default,
        {
          onDrop: this.onDrop,
          multiple: false,
          accept: this.props.accept,
          name: this.props.name,
          style: _extends({
            width: '100%',
            height: 200,
            borderWidth: 2,
            borderColor: 'rgb(102, 102, 102)',
            borderStyle: 'dashed',
            borderRadius: 5,
            position: 'relative',
            overflow: 'hidden',
            background: '#c5c5c5',
            cursor: 'pointer',
            marginBottom: '1rem'
          }, this.props.style)
        },
        !this.state.file && _react2.default.createElement('img', {
          alt: '',
          src: '/icons/icon-avatar.png',
          style: {
            width: '100%',
            height: '100%',
            objectFit: 'contain'
          }
        }),
        this.state.file && _react2.default.createElement('img', {
          alt: '',
          src: this.state.file.preview ? this.state.file.preview : this.state.file.uri,
          style: _extends({
            width: '100%',
            height: '100%',
            objectFit: 'cover'
          }, this.props.styleImg)
        }),
        _react2.default.createElement('div', {
          style: {
            position: 'absolute',
            top: 0,
            left: 0,
            right: 0,
            bottom: 0
          }
        }),
        _react2.default.createElement(
          'div',
          {
            style: _extends({
              position: 'absolute',
              top: 0,
              width: '100%',
              textAlign: 'right'
            }, this.props.styleButtons)
          },
          this.state.restore && this.state.btnRestore && _react2.default.createElement(
            _reactBootstrap.OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Restaurar original')
            },
            _react2.default.createElement(
              _reactstrap.Button,
              {
                size: 'sm',
                color: 'info',
                onClick: this.restoreIMG
              },
              _react2.default.createElement(_Icon2.default, { bootstrap: 'action-undo' })
            )
          ),
          this.state.file && _react2.default.createElement(
            _reactBootstrap.OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Eliminar')
            },
            _react2.default.createElement(
              _reactstrap.Button,
              {
                size: 'sm',
                color: 'danger',
                onClick: this.deleteIMG
              },
              _react2.default.createElement(_Icon2.default, { bootstrap: 'trash' })
            )
          )
        )
      );
    }
  }]);

  return FieldFileUpload;
}(_react.Component);

FieldFileUpload.defaultProps = {
  accept: 'image/png, image/jpeg, image/jpg',
  style: {},
  styleButtons: {},
  styleImg: {}
};

FieldFileUpload.propTypes = {
  accept: _propTypes2.default.string,
  name: _propTypes2.default.string,
  style: _propTypes2.default.object,
  styleButtons: _propTypes2.default.object,
  styleImg: _propTypes2.default.object,
  input: _propTypes2.default.object
};

exports.default = FieldFileUpload;