'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuTopMotion = function (_Component) {
  _inherits(MenuTopMotion, _Component);

  function MenuTopMotion(props) {
    _classCallCheck(this, MenuTopMotion);

    var _this = _possibleConstructorReturn(this, (MenuTopMotion.__proto__ || Object.getPrototypeOf(MenuTopMotion)).call(this, props));

    _this.state = {
      buttons: null
    };
    return _this;
  }

  _createClass(MenuTopMotion, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (nextProps.isOpen === true) {
        document.body.classList.add('modal-open');

        var buttons = [];
        if (nextProps.buttons && Array.isArray(nextProps.buttons.props.children)) {
          nextProps.buttons.props.children.map(function (b, bk) {
            if (b) {
              b = _react2.default.cloneElement(b, {
                key: 'button-' + bk,
                style: { flex: 1 }
              });
              buttons.push(b);
            }
            return b;
          });
        } else {
          var btn = _react2.default.cloneElement(nextProps.buttons, {
            key: 'button',
            style: { flex: 1 }
          });
          buttons.push(btn);
        }
        buttons.push(_react2.default.createElement(
          _reactstrap.Button,
          {
            style: { flex: 1 },
            key: 'close',
            size: 'md',
            onClick: function onClick() {
              return _this2.props.closeMenu(false);
            },
            name: 'close'
          },
          'Cerrar'
        ));

        this.setState({
          buttons: buttons
        });
      } else {
        document.body.classList.remove('modal-open');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        'wrapper',
        {
          className: 'MenuTopMotion',
          style: {
            visibility: this.props.isOpen ? 'visible' : 'hidden',
            transition: !this.props.isOpen ? 'visibility 0s linear 1s,opacity 1s linear' : ''
          }
        },
        this.props.backlock && _react2.default.createElement('div', {
          onClick: function onClick() {
            return _this3.props.closeMenu(false);
          },
          style: {
            visibility: this.props.isOpen ? 'visible' : 'hidden',
            transition: !this.props.isOpen ? 'visibility 0s linear 0.5s,opacity 0.5s linear' : ''
          },
          className: 'modal-backdrop fade ' + (this.props.isOpen ? 'show' : '')
        }),
        _react2.default.createElement(
          _reactstrap.Navbar,
          { color: this.props.backgroundColor,
            toggleable: true,
            className: 'animated-3 ' + (this.props.isOpen ? this.props.animation.open : this.props.animation.close)
          },
          this.props.children,
          _react2.default.createElement(
            'wrapper',
            {
              style: {
                display: 'flex',
                alignSelf: 'flex-start',
                flexWrap: 'wrap'
              }
            },
            this.state.buttons
          )
        )
      );
    }
  }]);

  return MenuTopMotion;
}(_react.Component);

MenuTopMotion.defaultProps = {
  backlock: true,
  backgroundColor: 'faded',
  animation: { open: 'slideInDown', close: 'slideOutUp' }
};

MenuTopMotion.propTypes = {
  backgroundColor: _propTypes2.default.string,
  backlock: _propTypes2.default.bool,
  animation: _propTypes2.default.object,
  isOpen: _propTypes2.default.bool,
  closeMenu: _propTypes2.default.func,
  children: _propTypes2.default.any,
  buttons: _propTypes2.default.any
};

exports.default = MenuTopMotion;