'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Sidebar = function (_Component) {
  _inherits(Sidebar, _Component);

  function Sidebar(props) {
    _classCallCheck(this, Sidebar);

    var _this = _possibleConstructorReturn(this, (Sidebar.__proto__ || Object.getPrototypeOf(Sidebar)).call(this, props));

    _this.state = {};
    _this._renderSidebarMenu = _this._renderSidebarMenu.bind(_this);
    _this._renderDropdownMenu = _this._renderDropdownMenu.bind(_this);
    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  _createClass(Sidebar, [{
    key: 'handleClick',
    value: function handleClick(e) {
      e.preventDefault();
      e.target.parentElement.classList.toggle('open');
    }
  }, {
    key: 'activeDropdown',
    value: function activeDropdown(routeName) {
      return window.location.pathname.indexOf(routeName) > -1 ? 'nav-item nav-dropdown open' : 'nav-item nav-dropdown';
    }
  }, {
    key: 'activeRoute',
    value: function activeRoute(menu) {
      return window.location.pathname.indexOf(menu.to) > -1 && window.location.pathname.length === menu.to.length ? 'active' : '';
    }
  }, {
    key: '_renderSidebarMenu',
    value: function _renderSidebarMenu(menu, key) {
      if (menu.divider) {
        return _react2.default.createElement('li', { key: key, className: 'divider' });
      }
      if (menu.title) {
        return _react2.default.createElement(
          'li',
          { key: key, className: 'nav-title' },
          menu.name
        );
      }
      if (menu.dropdown) {
        if (!menu.to) {
          alert('falta la key "to"'); // eslint-disable-line
          return;
        }
        return _react2.default.createElement(
          'li',
          { key: key, className: this.activeDropdown(menu.to) },
          _react2.default.createElement(
            'a',
            { className: 'nav-link nav-dropdown-toggle',
              href: '#',
              onClick: this.handleClick
            },
            menu.icon && _react2.default.createElement(_Icon2.default, menu.icon),
            menu.name
          ),
          _react2.default.createElement(
            'ul',
            { className: 'nav-dropdown-items' },
            menu.submenus.map(this._renderSidebarMenu)
          )
        );
      }

      if (!menu.to) {
        alert('falta la key "to"'); // eslint-disable-line
        return;
      }
      return _react2.default.createElement(
        'li',
        { key: key, className: 'nav-item' },
        _react2.default.createElement(
          _reactRouterDom.Link,
          { to: menu.to, className: 'nav-link ' + this.activeRoute(menu) },
          menu.icon && _react2.default.createElement(_Icon2.default, menu.icon),
          menu.name,
          menu.badge && _react2.default.createElement(
            'span',
            { className: 'badge ' + (menu.badge.style ? 'badge-' + menu.badge.style : 'badge-info') },
            menu.badge.name
          )
        )
      );
    }
  }, {
    key: '_renderDropdownMenu',
    value: function _renderDropdownMenu(submenu, key) {
      return _react2.default.createElement(
        'li',
        { className: 'nav-item' },
        _react2.default.createElement(
          _reactRouterDom.Link,
          { to: submenu.to, className: 'nav-link' },
          submenu.icon && _react2.default.createElement(_Icon2.default, submenu.icon),
          '\xA0 ',
          submenu.name,
          submenu.badge && _react2.default.createElement(
            'span',
            { className: 'badge ' + (submenu.badge.style ? 'badge-info' : 'badge-') },
            submenu.badge.name
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'sidebar' },
        _react2.default.createElement(
          'nav',
          { className: 'sidebar-nav' },
          _react2.default.createElement(
            'ul',
            { className: 'nav' },
            this.props.sidebarMenu.map(this._renderSidebarMenu)
          )
        )
      );
    }
  }]);

  return Sidebar;
}(_react.Component);

Sidebar.defaultProps = {
  sidebarMenu: []
};

Sidebar.propTypes = {
  sidebarMenu: _propTypes2.default.array
};

exports.default = Sidebar;