'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withFilter;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _reactBootstrap = require('react-bootstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _FieldDate = require('../FieldDate');

var _FieldDate2 = _interopRequireDefault(_FieldDate);

var _FieldDateTime = require('../FieldDateTime');

var _FieldDateTime2 = _interopRequireDefault(_FieldDateTime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withFilter(Component) {
  var withFilter = function (_React$Component) {
    _inherits(withFilter, _React$Component);

    function withFilter(props) {
      _classCallCheck(this, withFilter);

      var _this = _possibleConstructorReturn(this, (withFilter.__proto__ || Object.getPrototypeOf(withFilter)).call(this, props));

      var selectFilterType = null;
      var selectFilterValue = null;
      var filter = null;
      if (props.filter && _typeof(props.filter) === 'object' && props.filter.options) {
        filter = [];
        var saveFirstActive = true;
        for (var prop in props.filter.options) {
          filter.push(prop);
          if (saveFirstActive) {
            selectFilterValue = prop;
            selectFilterType = props.filter.options[prop];
            saveFirstActive = false;
          }
        }
      }

      _this.state = {
        filter: filter,
        selectFilterType: selectFilterType,
        selectFilterValue: selectFilterValue,
        inputFilterValue: ''
      };
      _this.handlerOnChangeSelectFilter = _this.handlerOnChangeSelectFilter.bind(_this);
      _this.handlerOnClickFindFilter = _this.handlerOnClickFindFilter.bind(_this);
      _this.handlerOnChangeInput = _this.handlerOnChangeInput.bind(_this);
      _this._renderSelectFilter = _this._renderSelectFilter.bind(_this);
      _this._renderFilter = _this._renderFilter.bind(_this);
      return _this;
    }

    _createClass(withFilter, [{
      key: 'handlerOnChangeInput',
      value: function handlerOnChangeInput(value) {
        this.setState({
          inputFilterValue: value
        });
      }
    }, {
      key: 'handlerOnClickFindFilter',
      value: function handlerOnClickFindFilter(prop, value) {
        var _this2 = this;

        var filter = [];
        if (value && value !== '') {
          if (this.props.filter.output && this.props.filter.output[prop]) {
            var _filter$push;

            filter.push((_filter$push = {}, _defineProperty(_filter$push, this.props.outputDefault.p || 'p', this.props.filter.output[prop].prop || prop), _defineProperty(_filter$push, this.props.outputDefault.v || 'v', this.props.filter.output[prop].value ? typeof this.props.filter.output[prop].value === 'function' ? this.props.filter.output[prop].value(value) : this.props.filter.output[prop].value : value), _defineProperty(_filter$push, this.props.outputDefault.t || 't', this.props.filter.output[prop].type || (this.state.selectFilterType === 'date' || this.state.selectFilterType === 'datetime' ? 'date' : undefined)), _defineProperty(_filter$push, this.props.outputDefault.e || 'e', this.props.filter.output[prop].exp ? this.props.filter.output[prop].exp : undefined), _filter$push));
          } else {
            var _filter$push2;

            filter.push((_filter$push2 = {}, _defineProperty(_filter$push2, this.props.outputDefault.p || 'p', prop), _defineProperty(_filter$push2, this.props.outputDefault.v || 'v', value), _defineProperty(_filter$push2, this.props.outputDefault.t || 't', this.state.selectFilterType === 'date' || this.state.selectFilterType === 'datetime' ? 'date' : undefined), _filter$push2));
          }
        }

        this.setState({
          inputFilterValue: value
        }, function () {
          return _this2.props.setActiveFilter(filter);
        });
      }
    }, {
      key: 'handlerOnChangeSelectFilter',
      value: function handlerOnChangeSelectFilter(value) {
        var _this3 = this;

        if (this.state.selectFilterType) {
          this.setState({
            selectFilterValue: value,
            selectFilterType: this.props.filter.options[value],
            inputFilterValue: ''
          }, function () {
            if (_this3.state.selectFilterType === 'text' || _this3.state.selectFilterType === 'number') {
              _this3.inputFilter.focus();
            }
          });
        } else {
          this.inputFilter.focus();
        }
      }
    }, {
      key: '_renderSelectFilter',
      value: function _renderSelectFilter(opt, kOpt) {
        return _react2.default.createElement(
          'option',
          {
            key: 'opt' + kOpt,
            value: opt
          },
          this.props.tHead[opt]
        );
      }
    }, {
      key: '_renderFilter',
      value: function _renderFilter() {
        var _this4 = this;

        if (this.props.filter) {
          return _react2.default.createElement(
            'div',
            { className: 'pull-right' },
            _react2.default.createElement(
              _reactstrap.InputGroup,
              null,
              _react2.default.createElement(
                _reactstrap.InputGroupButton,
                null,
                _react2.default.createElement(
                  'select',
                  {
                    style: { width: '100%' },
                    className: 'form-control',
                    value: this.state.selectFilterValue,
                    onChange: function onChange(e) {
                      return _this4.handlerOnChangeSelectFilter(e.currentTarget.value);
                    }
                  },
                  this.state.filter.map(this._renderSelectFilter)
                )
              ),
              this.state.selectFilterType && this.state.selectFilterType === 'date' && _react2.default.createElement(_FieldDate2.default, {
                styleFormGroup: { marginBottom: 0 },
                styleInputGroup: { height: '2.22rem' },
                type: 'text',
                formato: 'DD/MM/YYYY',
                input: { value: this.state.inputFilterValue },
                onSelected: function onSelected(value) {
                  return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, value);
                }
              }),
              this.state.selectFilterType && this.state.selectFilterType === 'datetime' && _react2.default.createElement(_FieldDateTime2.default, {
                styleFormGroup: { marginBottom: 0 },
                styleInputGroup: { height: '2.22rem' },
                type: 'text',
                formato: 'DD/MM/YYYY',
                input: { value: this.state.inputFilterValue },
                onSelected: function onSelected(value) {
                  return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, value);
                }
              }),
              this.state.selectFilterType && Array.isArray(this.state.selectFilterType) && _react2.default.createElement(
                'select',
                {
                  className: 'form-control',
                  value: this.state.inputFilterValue,
                  onChange: function onChange(e) {
                    return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, e.currentTarget.value);
                  }
                },
                _react2.default.createElement('option', { value: '' }),
                this.state.selectFilterType.map(function (v, k) {
                  return _react2.default.createElement(
                    'option',
                    { key: 'option-' + k, value: v.value || v },
                    v.label || v
                  );
                })
              ),
              (!this.state.selectFilterType || this.state.selectFilterType === 'text' || this.state.selectFilterType === 'number') && _react2.default.createElement('input', {
                type: this.state.selectFilterType,
                ref: function ref(input) {
                  _this4.inputFilter = input;
                },
                className: 'form-control',
                onChange: function onChange(e) {
                  return _this4.handlerOnChangeInput(e.currentTarget.value);
                },
                onKeyPress: function onKeyPress(e) {
                  if (e.which === 13 || e.charCode === 13 || e.keyCode === 13) {
                    _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, e.currentTarget.value);
                  }
                }
              }),
              _react2.default.createElement(
                _reactBootstrap.OverlayTrigger,
                {
                  placement: 'top',
                  overlay: this.props._renderTooltip('Buscar')
                },
                _react2.default.createElement(
                  _reactstrap.InputGroupAddon,
                  {
                    style: { cursor: 'pointer' },
                    onClick: function onClick(e) {
                      return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, _this4.state.inputFilterValue);
                    }
                  },
                  _react2.default.createElement(_Icon2.default, {
                    bootstrap: 'magnifier'
                  })
                )
              )
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, _extends({
          _renderFilter: this._renderFilter
        }, this.props));
      }
    }]);

    return withFilter;
  }(_react2.default.Component);

  withFilter.defaultProps = {
    tHead: {},
    outputDefault: {}
  };

  withFilter.propTypes = {
    filter: _propTypes2.default.object,
    tHead: _propTypes2.default.object,
    outputDefault: _propTypes2.default.object,
    _renderTooltip: _propTypes2.default.func,
    setActiveFilter: _propTypes2.default.func
  };

  return withFilter;
}