'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withLimit;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withLimit(Component) {
  var withLimit = function (_React$Component) {
    _inherits(withLimit, _React$Component);

    function withLimit(props) {
      _classCallCheck(this, withLimit);

      var _this = _possibleConstructorReturn(this, (withLimit.__proto__ || Object.getPrototypeOf(withLimit)).call(this, props));

      var limit = null;
      if (props.limit) {
        if (_typeof(props.limit) === 'object' && props.limit.options) {
          limit = props.limit;
        } else {
          limit = {
            options: [10, 25, 50, 100, 1000]
          };
        }
      }

      _this.state = {
        limit: limit
      };
      _this.handlerOnChange = _this.handlerOnChange.bind(_this);
      _this._renderLimit = _this._renderLimit.bind(_this);
      return _this;
    }

    _createClass(withLimit, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (this.state.limit) {
          this.props.setActiveLimit(this.state.limit.options[0], true);
        }
      }
    }, {
      key: 'handlerOnChange',
      value: function handlerOnChange(value) {
        this.props.setActiveLimit(parseInt(value, 10));
      }
    }, {
      key: '_renderLimitElements',
      value: function _renderLimitElements(opt, kOpt) {
        return _react2.default.createElement(
          'option',
          {
            key: 'opt-' + kOpt,
            value: opt
          },
          opt
        );
      }
    }, {
      key: '_renderLimit',
      value: function _renderLimit() {
        var _this2 = this;

        if (this.state.limit) {
          return _react2.default.createElement(
            'div',
            { className: 'pull-left' },
            'Mostrar \xA0',
            _react2.default.createElement(
              'select',
              {
                value: this.props.activeLimit,
                onChange: function onChange(e) {
                  return _this2.handlerOnChange(e.currentTarget.value);
                }
              },
              this.state.limit.options.map(this._renderLimitElements)
            ),
            '\xA0 registros'
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, _extends({
          _renderLimit: this._renderLimit
        }, this.props));
      }
    }]);

    return withLimit;
  }(_react2.default.Component);

  withLimit.defaultProps = {};

  withLimit.propTypes = {
    limit: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.object]),
    setActiveLimit: _propTypes2.default.func,
    activeLimit: _propTypes2.default.number
  };

  return withLimit;
}