'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withMultiFilter;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ramda = require('ramda');

var _deepcopy = require('deepcopy');

var _deepcopy2 = _interopRequireDefault(_deepcopy);

var _reactstrap = require('reactstrap');

var _reactBootstrap = require('react-bootstrap');

var _Card = require('../Card');

var _Card2 = _interopRequireDefault(_Card);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _FieldDate = require('../FieldDate');

var _FieldDate2 = _interopRequireDefault(_FieldDate);

var _FieldDateTime = require('../FieldDateTime');

var _FieldDateTime2 = _interopRequireDefault(_FieldDateTime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // const EQ        = '=';
// const NEQ       = '<>';
// const LT        = '<';
// const LTE       = '<=';
// const GT        = '>';
// const GTE       = '>=';
// const IS        = '='; // no difference with EQ
// const IN        = 'IN';
// const NIN       = 'NIN';
// const CONTAINS  = 'CONTAINS';

function withMultiFilter(Component) {
  var withMultiFilter = function (_React$Component) {
    _inherits(withMultiFilter, _React$Component);

    function withMultiFilter(props) {
      _classCallCheck(this, withMultiFilter);

      var _this = _possibleConstructorReturn(this, (withMultiFilter.__proto__ || Object.getPrototypeOf(withMultiFilter)).call(this, props));

      var fields = [];
      for (var prop in props.multiFilter) {
        if (props.tHead[prop]) {
          fields.push({ value: prop, label: props.tHead[prop], showAlways: props.multiFilter[prop].showAlways });
        } else if (props.multiFilter[prop].label) {
          fields.push({ value: prop, label: props.multiFilter[prop].label, showAlways: props.multiFilter[prop].showAlways });
        }
      }

      _this.state = {
        fields: fields,
        fieldsBck: fields,
        fieldsUsados: {},
        filtros: [{ field: '', criterio: '', valor: '' }]
      };
      _this.handlerResetear = _this.handlerResetear.bind(_this);
      _this.handlerAgregarFiltro = _this.handlerAgregarFiltro.bind(_this);
      _this.handlerEliminarFiltro = _this.handlerEliminarFiltro.bind(_this);
      _this.handlerGuardarLabel = _this.handlerGuardarLabel.bind(_this);
      _this.handlerGuardarCriterio = _this.handlerGuardarCriterio.bind(_this);
      _this.handlerGuardarValue = _this.handlerGuardarValue.bind(_this);
      _this.handlerFiltrar = _this.handlerFiltrar.bind(_this);
      _this.recalculoFieldsUsados = _this.recalculoFieldsUsados.bind(_this);
      _this.saveFiltros = _this.saveFiltros.bind(_this);
      _this._renderMultiFilter = _this._renderMultiFilter.bind(_this);
      _this._renderFiltro = _this._renderFiltro.bind(_this);
      _this._renderCriterio = _this._renderCriterio.bind(_this);
      _this._renderCampo = _this._renderCampo.bind(_this);
      return _this;
    }

    _createClass(withMultiFilter, [{
      key: 'handlerResetear',
      value: function handlerResetear(e) {
        if (this.Card.state.collapseOpen) {
          e.stopPropagation();
        }
        this.setState({
          fields: this.state.fieldsBck,
          fieldsUsados: {},
          filtros: [{ field: '', criterio: '', valor: '' }]
        });
      }
    }, {
      key: 'handlerAgregarFiltro',
      value: function handlerAgregarFiltro(e) {
        if (this.Card.state.collapseOpen) {
          e.stopPropagation();
        }
        var filtros = (0, _deepcopy2.default)(this.state.filtros);
        filtros.push({ field: '', criterio: '', valor: '' });
        this.saveFiltros(filtros);
      }
    }, {
      key: 'handlerEliminarFiltro',
      value: function handlerEliminarFiltro(kf) {
        this.recalculoFieldsUsados(undefined, kf);

        var filtros = (0, _deepcopy2.default)(this.state.filtros);
        filtros.splice(kf, 1);
        this.saveFiltros(filtros);
      }
    }, {
      key: 'handlerGuardarLabel',
      value: function handlerGuardarLabel(value, kf) {
        this.recalculoFieldsUsados(value, kf);

        var filtros = (0, _deepcopy2.default)(this.state.filtros);
        filtros[kf] = (0, _ramda.merge)(filtros[kf], { field: value, criterio: '', valor: '' });
        this.saveFiltros(filtros);
      }
    }, {
      key: 'handlerGuardarCriterio',
      value: function handlerGuardarCriterio(value, kf) {
        var filtros = (0, _deepcopy2.default)(this.state.filtros);
        var criteria = this.props.multiFilter[this.state.filtros[kf].field].criteria.filter(function (c) {
          return c.v === value;
        })[0];
        filtros[kf] = (0, _ramda.merge)(filtros[kf], { criterio: value, valor: criteria.d || '' });
        this.saveFiltros(filtros);
      }
    }, {
      key: 'handlerGuardarValue',
      value: function handlerGuardarValue(value, kf) {
        var filtros = (0, _deepcopy2.default)(this.state.filtros);
        filtros[kf] = (0, _ramda.merge)(filtros[kf], { valor: value });
        this.saveFiltros(filtros);
      }
    }, {
      key: 'handlerFiltrar',
      value: function handlerFiltrar() {
        var _this2 = this;

        var normalizeFiltros = (0, _deepcopy2.default)(this.state.filtros);
        normalizeFiltros = normalizeFiltros.filter(function (f) {
          return f.field !== '' && f.criterio !== '' && f.valor !== '';
        }).map(function (f, kf) {
          f[_this2.props.outputDefault.p || 'p'] = _this2.props.multiFilter[f.field].prop ? _this2.props.multiFilter[f.field].prop : f.field;
          f[_this2.props.outputDefault.v || 'v'] = f.valor;
          f[_this2.props.outputDefault.t || 't'] = _this2.props.multiFilter[f.field].type === 'date' || _this2.props.multiFilter[f.field].type === 'datetime' ? 'date' : undefined;
          f[_this2.props.outputDefault.e || 'e'] = f.criterio;
          delete f.field;
          delete f.valor;
          delete f.criterio;
          return f;
        });
        this.props.setActiveFilter(normalizeFiltros);
      }
    }, {
      key: 'saveFiltros',
      value: function saveFiltros(filtros) {
        this.setState({ filtros: filtros });
      }
    }, {
      key: 'recalculoFieldsUsados',
      value: function recalculoFieldsUsados(value, kf) {
        var fields = (0, _deepcopy2.default)(this.state.fields);
        var fieldsUsados = (0, _deepcopy2.default)(this.state.fieldsUsados);
        fieldsUsados[kf] = value;

        fields = fields.map(function (f) {
          f.usado = false;
          for (var prop in fieldsUsados) {
            if (f.value === fieldsUsados[prop]) {
              f.usado = true;
            }
          }
          return f;
        });

        this.setState({
          fieldsUsados: fieldsUsados,
          fields: fields
        });
      }
    }, {
      key: '_renderLabels',
      value: function _renderLabels(kf) {
        var _this3 = this;

        return _react2.default.createElement(
          'select',
          {
            value: this.state.filtros[kf].field,
            className: 'form-control',
            onChange: function onChange(e) {
              return _this3.handlerGuardarLabel(e.currentTarget.value, kf);
            }
          },
          _react2.default.createElement('option', { value: '' }),
          this.state.fields.filter(function (f) {
            return !f.usado || f.value === _this3.state.filtros[kf].field || f.showAlways;
          }).map(function (f, kf) {
            return _react2.default.createElement(
              'option',
              {
                key: 'opt-' + kf,
                value: f.value
              },
              f.label
            );
          })
        );
      }
    }, {
      key: '_renderCriterioDisabled',
      value: function _renderCriterioDisabled(kf) {
        return _react2.default.createElement('select', {
          value: this.state.filtros[kf].criterio,
          className: 'form-control',
          disabled: true
        });
      }
    }, {
      key: '_renderCriterio',
      value: function _renderCriterio(field, kf) {
        var _this4 = this;

        if (this.props.multiFilter[field].criteria) {
          return _react2.default.createElement(
            'select',
            {
              value: this.state.filtros[kf].criterio,
              className: 'form-control',
              onChange: function onChange(e) {
                return _this4.handlerGuardarCriterio(e.currentTarget.value, kf);
              }
            },
            _react2.default.createElement('option', { value: '' }),
            this.props.multiFilter[field].criteria.map(function (cr, kcr) {
              return _react2.default.createElement(
                'option',
                {
                  key: 'opt-' + kcr,
                  value: cr.v
                },
                cr.l
              );
            })
          );
        } else {
          return this._renderCriterioDisabled(kf);
        }
      }
    }, {
      key: '_renderCampoDisabled',
      value: function _renderCampoDisabled(kf) {
        return _react2.default.createElement('input', {
          className: 'form-control',
          value: this.state.filtros[kf].valor,
          disabled: true
        });
      }
    }, {
      key: '_renderCampo',
      value: function _renderCampo(field, kf) {
        var _this5 = this;

        if (this.props.multiFilter[field].type === 'date') {
          return _react2.default.createElement(_FieldDate2.default, {
            styleFormGroup: { marginBottom: 0 },
            styleInputGroup: { height: '2.22rem' },
            type: 'text',
            formato: 'DD/MM/YYYY',
            input: { value: this.state.filtros[kf].valor },
            onSelected: function onSelected(value) {
              return _this5.handlerGuardarValue(value, kf);
            }
          });
        } else if (this.props.multiFilter[field].type === 'datetime') {
          return _react2.default.createElement(_FieldDateTime2.default, {
            styleFormGroup: { marginBottom: 0 },
            styleInputGroup: { height: '2.22rem' },
            type: 'text',
            formato: 'DD/MM/YYYY',
            input: { value: this.state.filtros[kf].valor },
            onSelected: function onSelected(value) {
              return _this5.handlerGuardarValue(value, kf);
            }
          });
        } else if (Array.isArray(this.props.multiFilter[field].type)) {
          return _react2.default.createElement(
            'select',
            {
              className: 'form-control',
              value: this.state.filtros[kf].valor,
              onChange: function onChange(e) {
                return _this5.handlerGuardarValue(e.currentTarget.value, kf);
              }
            },
            _react2.default.createElement('option', { value: '' }),
            this.props.multiFilter[field].type.map(function (opt, kOpt) {
              return _react2.default.createElement(
                'option',
                { key: 'opt-' + kOpt, value: opt.value || opt },
                opt.label || opt
              );
            })
          );
        } else if (this.props.multiFilter[field].type === 'text' || this.props.multiFilter[field].type === 'number') {
          return _react2.default.createElement('input', {
            type: this.props.multiFilter[field].type,
            className: 'form-control',
            value: this.state.filtros[kf].valor,
            onChange: function onChange(e) {
              return _this5.handlerGuardarValue(e.currentTarget.value, kf);
            }
          });
        } else {
          return this._renderCampoDisabled(kf);
        }
      }
    }, {
      key: '_renderFiltro',
      value: function _renderFiltro(f, kf) {
        var _this6 = this;

        return _react2.default.createElement(
          _reactstrap.Row,
          { key: 'filtro-' + kf, style: { width: '100%', margin: '0 0 5px' } },
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12', lg: '3' },
            _react2.default.createElement(
              'div',
              { style: { display: 'flex' } },
              _react2.default.createElement(
                'strong',
                { style: { padding: '0.5rem 0.75rem 0.5rem 0', flex: 'none' } },
                kf + 1,
                ' -'
              ),
              this._renderLabels(kf)
            )
          ),
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12', lg: '2' },
            this.state.filtros[kf].field && this.state.filtros[kf].field !== '' ? this._renderCriterio(this.state.filtros[kf].field, kf) : this._renderCriterioDisabled(kf)
          ),
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12', lg: '3' },
            this.state.filtros[kf].field && this.state.filtros[kf].field !== '' ? this._renderCampo(this.state.filtros[kf].field, kf) : this._renderCampoDisabled(kf)
          ),
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12', lg: '3' },
            kf !== 0 && _react2.default.createElement(
              _reactBootstrap.OverlayTrigger,
              {
                placement: 'top',
                overlay: this.props._renderTooltip('Eliminar filtro')
              },
              _react2.default.createElement(
                _reactstrap.Button,
                {
                  color: 'danger',
                  size: 'sm',
                  onClick: function onClick() {
                    return _this6.handlerEliminarFiltro(kf);
                  }
                },
                _react2.default.createElement(_Icon2.default, { bootstrap: 'trash' })
              )
            )
          )
        );
      }
    }, {
      key: '_renderMultiFilter',
      value: function _renderMultiFilter() {
        var _this7 = this;

        if (this.props.multiFilter) {
          return _react2.default.createElement(
            _Card2.default,
            {
              ref: function ref(Card) {
                _this7.Card = Card;
              },
              fullWidth: true,
              size: { sm: 12 },
              icon: { bootstrap: 'diamond' },
              title: 'Filtros avanzados',
              topColor: 'dark',
              animated: true,
              nextTitle: _react2.default.createElement(
                'wrapper',
                { className: 'pull-right' },
                _react2.default.createElement(
                  _reactBootstrap.OverlayTrigger,
                  {
                    placement: 'top',
                    overlay: this.props._renderTooltip('Resetear')
                  },
                  _react2.default.createElement(
                    _reactstrap.Button,
                    {
                      color: 'dark',
                      size: 'sm',
                      onClick: this.handlerResetear
                    },
                    _react2.default.createElement(_Icon2.default, { bootstrap: 'refresh' })
                  )
                ),
                ' \xA0',
                _react2.default.createElement(
                  _reactBootstrap.OverlayTrigger,
                  {
                    placement: 'top',
                    overlay: this.props._renderTooltip('Sumar filtro')
                  },
                  _react2.default.createElement(
                    _reactstrap.Button,
                    {
                      color: 'dark',
                      size: 'sm',
                      onClick: this.handlerAgregarFiltro
                    },
                    _react2.default.createElement(_Icon2.default, { bootstrap: 'plus' })
                  )
                )
              )
            },
            this.state.filtros.map(this._renderFiltro),
            _react2.default.createElement(
              _reactstrap.Row,
              { style: { width: '100%', margin: '0 0 5px' } },
              _react2.default.createElement(
                _reactstrap.Col,
                { className: 'col-12' },
                _react2.default.createElement('hr', null),
                _react2.default.createElement(
                  _reactstrap.Button,
                  {
                    color: 'dark',
                    onClick: this.handlerFiltrar
                  },
                  'Filtrar'
                )
              )
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, _extends({
          _renderMultiFilter: this._renderMultiFilter
        }, this.props));
      }
    }]);

    return withMultiFilter;
  }(_react2.default.Component);

  withMultiFilter.defaultProps = {
    outputDefault: {}
  };

  withMultiFilter.propTypes = {
    // withTooltip
    _renderTooltip: _propTypes2.default.func,
    multiFilter: _propTypes2.default.object,
    tHead: _propTypes2.default.object,
    outputDefault: _propTypes2.default.object,
    setActiveFilter: _propTypes2.default.func
  };

  return withMultiFilter;
}