'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withSortLimitFilterPageFunctions;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withSortLimitFilterPageFunctions(Component) {
  var withSortLimitFilterPageFunctions = function (_React$Component) {
    _inherits(withSortLimitFilterPageFunctions, _React$Component);

    function withSortLimitFilterPageFunctions(props) {
      _classCallCheck(this, withSortLimitFilterPageFunctions);

      var _this = _possibleConstructorReturn(this, (withSortLimitFilterPageFunctions.__proto__ || Object.getPrototypeOf(withSortLimitFilterPageFunctions)).call(this, props));

      _this.state = {
        activeLimit: 0,
        activePage: 0,
        activeSort: [],
        activeFilter: []
      };
      _this.setActiveLimit = _this.setActiveLimit.bind(_this);
      _this.setActivePage = _this.setActivePage.bind(_this);
      _this.setActiveSort = _this.setActiveSort.bind(_this);
      _this.setActiveFilter = _this.setActiveFilter.bind(_this);
      _this.returnSortLimitFilterPage = _this.returnSortLimitFilterPage.bind(_this);
      return _this;
    }

    _createClass(withSortLimitFilterPageFunctions, [{
      key: 'setActiveLimit',
      value: function setActiveLimit(activeLimit, init) {
        var _this2 = this;

        this.setState({
          activeLimit: activeLimit,
          activePage: 1
        }, function () {
          return !init && _this2.returnSortLimitFilterPage();
        });
      }
    }, {
      key: 'setActivePage',
      value: function setActivePage(activePage, init) {
        var _this3 = this;

        this.setState({
          activePage: activePage
        }, function () {
          return !init && _this3.returnSortLimitFilterPage();
        });
      }
    }, {
      key: 'setActiveSort',
      value: function setActiveSort(activeSort, init) {
        var _this4 = this;

        this.setState({
          activeSort: activeSort
        }, function () {
          return !init && _this4.returnSortLimitFilterPage();
        });
      }
    }, {
      key: 'setActiveFilter',
      value: function setActiveFilter(activeFilter, init) {
        var _this5 = this;

        this.setState({
          activeFilter: activeFilter,
          activePage: 1
        }, function () {
          return !init && _this5.returnSortLimitFilterPage();
        });
      }
    }, {
      key: 'calculateEntries',
      value: function calculateEntries(page, perPage) {
        return page * perPage - perPage;
      }
    }, {
      key: 'returnSortLimitFilterPage',
      value: function returnSortLimitFilterPage() {
        var activeFilter = this.state.activeFilter.length !== 0 ? this.state.activeFilter : undefined;
        var activeSort = this.state.activeSort.length !== 0 ? this.state.activeSort : undefined;
        var activeOffset = void 0;
        var activeLimit = void 0;
        // chequeo si existe la propiedad limit sino utilizo la perPage de pagination
        if (this.props.limit) {
          activeOffset = this.calculateEntries(this.state.activePage, this.state.activeLimit);
          activeLimit = this.state.activeLimit;
        } else if (this.props.pagination.perPage) {
          activeOffset = this.calculateEntries(this.state.activePage, this.props.pagination.perPage);
          activeLimit = this.props.pagination.perPage;
        }
        this.props.returnSortPaginationAndFilter && this.props.returnSortPaginationAndFilter(activeFilter, activeSort, activeLimit, activeOffset);
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, _extends({
          activeLimit: this.state.activeLimit,
          activePage: this.state.activePage,
          activeSort: this.state.activeSort,
          activeFilter: this.state.activeFilter,
          setActiveLimit: this.setActiveLimit,
          setActivePage: this.setActivePage,
          setActiveSort: this.setActiveSort,
          setActiveFilter: this.setActiveFilter
        }, this.props));
      }
    }]);

    return withSortLimitFilterPageFunctions;
  }(_react2.default.Component);

  withSortLimitFilterPageFunctions.defaultProps = {};

  withSortLimitFilterPageFunctions.propTypes = {
    returnSortPaginationAndFilter: _propTypes2.default.func,
    pagination: _propTypes2.default.object,
    limit: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.object])
  };

  return withSortLimitFilterPageFunctions;
}